from cvsgui.Macro import *
from cvsgui.ColorConsole import *
from cvsgui.Cvs import *
from cvsgui.CvsEntry import *
from cvsgui.CvsLog import *
import cvsgui.App, os, sys
import glob
import win32api
import win32file
import win32process
import win32event
import win32con
import commands
import TransferAPV

# Once I am correctly done with this, the clarion utility should just do the DDE stuff with Clarion, and that's it.

class ReloadApp(Macro):
	def __init__(self):
		Macro.__init__(self, "Reload Application", MACRO_SELECTION, 0, "Clarion CVS" )

	def Run(self):
		""" This macro works on the assumption that an 'application' directory has been selected,
		sub-directory of a 'cvsProduct' directory. Errors are triggered in regards of this assumption.
		
		If everything is correct, the Application Options.APV file is read to know which modules should be part
		of the Application, and the results are compared to the list of APV files in the directory.
		
		Then they are all concatenated together, the resulting TXA file is copied to the 'Product' directory, and
		our utility BG_DDE_CVS is called with the name of the txa and of the resulting application passed on the
		command line.
	   Returns nothing."""
		# At first, we test we have the proper setup to run this
		myEnv = os.getenv('c6root')
		if myEnv == None:
			console = ColorConsole()
			console << kRed << "You have not set an environment variable 'c6root' pointing to your Clarion 6 root directory!!!\n"
			del console

		if myEnv != None:
			sel = cvsgui.App.GetSelection()
			for s in sel:
			   AppName = s.GetFullName()
			   # Here I need to check that this is indeed a CVS directory with .apv files....
			   # First, check for an existing CVS directory
			   #print AppName
			   CVSDir = AppName + '\\CVS'
			   y = int(os.path.isdir(CVSDir))
			   if y == 0:
				   console = ColorConsole()
				   console << kRed << "This directory does not seem to be a CVS directory!!!\n"
			   elif y == 1:
					# Second, Check for *.apv files.....
					list = glob.glob('*.apv')
					w = len(list)
					if w == 0:
					   console = ColorConsole()
					   console << kRed << "This directory does not seem to contain any APV file!!\n"
					   console << kRed << "Maybe you want to use another macro: Reload Whole Product.\n"
					elif w >= 1:
						x = int(os.path.isdir(AppName))
						if x == 0:
							console = ColorConsole()
							console << kRed << "You must select an APP module directory containing your APV files!!!\n"
							del console
						elif x == 1:
							os.chdir(AppName)
							console = ColorConsole()
							console << kBlue << "Starting to rebuild " + AppName + "\n"
							TransferAPV.RebuildAPP(AppName)
							console << kBlue << "Rebuilding done!\n"				       				
									   
					  # mon seul vrai probleme c'est que je ne peux pas savoir lorsque c'est fini pour pouvoir
					  # faire le menage apres, et pas avant....				       
										
# il me faut aussi dupliquer ca pour un dictionnaire.

class ReloadProd(Macro):
    def __init__(self):
		Macro.__init__(self, "Reload Whole Product", MACRO_SELECTION, 0, "Clarion CVS" )

    def Run(self):
        # At first, we test we have the proper setup to run this
			myEnv = os.getenv('c6root')
			if myEnv == None:
				console = ColorConsole()
				console << kRed << "You have not set an environment variable 'c6root' pointing to your Clarion 6 root directory!!!\n"
				del console

			 # Here i need to check that I am on a directory having a sub-directory of cvs + directory name
			if myEnv != None:
				sel = cvsgui.App.GetSelection()
				# as it is a directory, I know I will have only one, but this is still OK
				for s in sel:
					AppName = os.getcwd()
					SplitAppName = os.path.split(AppName)
					# First, check for an existing CVS directory
					CVSDir = AppName + '\\cvs'+SplitAppName[1]
					y = int(os.path.isdir(CVSDir))
					if y == 0:
					    console = ColorConsole()
					    console << kRed << "The directory " + CVSDir + " does not seem to contain a 'cvsProduct' sub-directory!!!\n"
					elif y == 1:
					   # At this level, I have to load a list to have all the subdirs in it
					   console = ColorConsole()
					   console << kBlue << "Rebuilding applications for product " + SplitAppName[1] + " started...\n"	
					   list = os.listdir(CVSDir)
					   w = len(list)
					   if w == 0:
							console = ColorConsole()
							console << kBrown << "The directory " + CVSDir + " does not seem to contain any sub-directory!!\n"					
					   elif w >= 1:							
							# rebuild any dictionary first, then and only then, the apps.
							for ndy in range(0 , w):								
							   # carefull here to avoid the CVS directory, or any directory not having *.APV inside
							   # should check the list, and remove any dir not matching that criteria
								if list[ndy] != "CVS":
									myDir = CVSDir + '\\' + list[ndy]									
									dctlist = glob.glob(myDir + '\\' + '*.DCV')									
									y = len(dctlist)
									if y >= 1:										
										os.chdir(myDir)
										console = ColorConsole()
										console << kBlue << "Starting to rebuild " + dctlist[0] + "\n"
										TransferAPV.RebuildDCT(myDir)
										console << kBlue << "Rebuilding done!\n"
										console <<kBlue << "Waiting for BG_DDE_CVS to be done with the dictionary ...\n"
										TransferAPV.WaitForProcess()
							
							# Now we can take care of the apps
							for ndx in range(0 , w):
							    # carefull here to avoid the CVS directory, or any directory not having *.APV inside
							    # should check the list, and remove any dir not matching that criteria
							    if list[ndx] != "CVS":
									myPath = CVSDir + '\\' + list[ndx]
									filelist = glob.glob(myPath+ '\\'+ '*.apv')									
									w = len(filelist)									
									if w == 0:
									    console = ColorConsole()
									    console << kBrown << myPath + " does not seem to contain any APV file. Skipped...\n"
									elif w >= 1:
										os.chdir(myPath)
										console = ColorConsole()
										console << kBlue << "Starting to rebuild " + myPath + "\n"										
										TransferAPV.RebuildAPP(myPath)
										console << kBlue << "Rebuilding done!\n"
				                 
					console << kBlue << "...done rebuilding " + SplitAppName[1] + "\n"
					del console

class ReloadDct(Macro):
	def __init__(self):
		Macro.__init__(self, "Reload Dictionary", MACRO_SELECTION, 0, "Clarion CVS" )

	def Run(self):
		""" This macro works on the assumption that a 'dictionary' file has been selected, or the directory containing it,
		a sub-directory of a 'cvsProduct' directory. Errors are triggered in regards of this assumption.
		
		If everything is correct, the Application Options.APV file is read to know the name of the dictionary file,
		and the results are compared to the list of DCV files in the directory. (Assumption is made there is only one DCV per directory)
		
		The DCV file is copied to the 'Product' directoryas a TXD file, and
	   our utility BG_DDE_CVS is called with the name of the txd and of the resulting dictionary passed on the command line.
		
	   Returns nothing."""
	   # At first, we test we have the proper setup to run this
		myEnv = os.getenv('c6root')
		if myEnv == None:
			console = ColorConsole()
			console << kRed << "You have not set an environment variable 'c6root' pointing to your Clarion 6 root directory!!!\n"
			del console
		
		if myEnv != None:
			sel = cvsgui.App.GetSelection()
			myfile = ""
			for s in sel:
				# here I need to decide if a dcv file has been selected, or if it is a directory.
				myselection = s.GetFullName()
				fileordir = int(os.path.isfile(myselection))
				if fileordir == 0:
					directorytotest = myselection + '\\CVS'
					y = int(os.path.isdir(directorytotest))
					if y == 0:
						console = ColorConsole()
						console << kRed << "This directory does not seem to be a CVS directory!!!\n"
					elif y == 1:
						list = glob.glob("*.dcv")
						w = len(list)
						if w == 0:
							console = ColorConsole()
							console << kRed << "This directory does not seem to contain any DCV file!!\n"
						elif w > 1:
							console = ColorConsole()
							console << kRed << "This macro assumes an error. There is more than 1 DCV file\n"
							console << kRed << "in this directory. Only the dictionary found in Application Options\n"
							console << kRed << "will be rebuild.\n"
						else:
							mydirectory = myselection
							myfile = list[0]
														
				else:
					( mydirectory, myfile ) = os.path.split(myselection)
					
			if len(myfile) != 0:
				console = ColorConsole()
				console << kBlue << "Starting to rebuild " + myfile + "\n"
				TransferAPV.RebuildDCT(mydirectory)
				console << kBlue << "Rebuilding done!\n"
                      


class PrepareForCVS(Macro):
	
    def __init__(self):
        Macro.__init__(self, "Prepare Current Directory", MACRO_SELECTION, 0, "Clarion CVS")

    def Run(self):
        sel = cvsgui.App.GetSelection()
        for s in sel:
				ModuleName = os.getcwd()
				console = ColorConsole()
				console << kBlue << "Preparing " + ModuleName + " to be used with WinCVS and Clarion6.\n"
				# so now, for each APP in this directory, I have to create:
				# - 1 first, as subdirectory, with the same name, prefixed with cvs
				# - 2 second, subdirectories
				# - so, to do 1, I need here to have a list of all APP in that directory
				filelist = glob.glob('*.app')
				w = len(filelist)
				if w == 0:
					console = ColorConsole()
					console << kBrown <<"The directory " + ModuleName + " does not seem to contain any Application file.\n"					
				else:
					# - need to check if I have already a cvs prefixed directory
					SplitModuleName = os.path.split(ModuleName)
					# First, check for an existing CVS directory
					CVSDir = ModuleName + '\\cvs'+SplitModuleName[1]
					y = int(os.path.isdir(CVSDir))
					if y == 1:
						console << kBrown << "Directory " + CVSDir + " exists already. Not doing anything.....\n"
					elif y == 0:
						# directory does not exists, create it
						os.mkdir(CVSDir)
						console << kBlue << "Create directory " + CVSDir + ".\n"
						# Now, create a directory for each app in the directory
						listlength = len(filelist)
						for ndx in range(0 , listlength):
							SplitAppName = os.path.splitext(filelist[ndx])
							NewDir = CVSDir + '\\' + SplitAppName[0]
							os.mkdir(NewDir)
							console << kBlue << "Create directory " + NewDir + ".\n"
						
					console << kBlue << "...done Preparing " + ModuleName + " for CVS.\n"
					del console




PrepareForCVS()
ReloadDct()
ReloadProd()
ReloadApp()

